SystemOrganization addCategory: #ConfigurationOfSHMaBase!

Object subclass: #ConfigurationOfSHMaBase
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSHMaBase'!

!ConfigurationOfSHMaBase class methodsFor: 'development support' stamp: 'StuartHerring 6/16/2012 12:48'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSHMaBase class methodsFor: 'private' stamp: 'StuartHerring 6/16/2012 12:48'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSHMaBase class methodsFor: 'private' stamp: 'StuartHerring 6/16/2012 12:48'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSHMaBase class methodsFor: 'private' stamp: 'StuartHerring 6/16/2012 12:48'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSHMaBase class methodsFor: 'metacello tool support' stamp: 'StuartHerring 6/16/2012 12:48'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSHMaBase class methodsFor: 'loading' stamp: 'StuartHerring 6/16/2012 12:48'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSHMaBase class methodsFor: 'loading' stamp: 'StuartHerring 6/16/2012 12:48'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSHMaBase class methodsFor: 'loading' stamp: 'StuartHerring 6/16/2012 12:48'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSHMaBase class methodsFor: 'accessing' stamp: 'StuartHerring 6/16/2012 12:48'!
project

	^self new project! !

!ConfigurationOfSHMaBase class methodsFor: 'development support' stamp: 'StuartHerring 6/16/2012 12:48'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSHMaBase methodsFor: 'baselines' stamp: 'StuartHerring 6/16/2012 13:29'!
baseline13: spec
	<version: '1.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://squeaksource.com/MaBase'.
		spec 
			package: 'Collections-BTree';
			package: 'Ma-Core';
			package: 'Ma-Collections';
			package: 'Ma-Ascii-Report';
			package: 'Ma-Statistics';
			package: 'Ma-Search';
			package: 'Ma-Serializer-Core';
			package: 'Ma-Serializer-Tests' with: [
				spec requires: #('Ma-Serializer-Core' ). ].
		spec 
			group: 'default' with: #('Base');
			group: 'Base' with: #('Collections-BTree' 'Ma-Core' 'Ma-Collections' 'Ma-Ascii-Report' 'Ma-Statistics' 'Ma-Search' 'Ma-Serializer-Core' 'Ma-Serializer-Pharo-Core' );
			group: 'Tests' with: #('Base' 'Ma-Serializer-Tests' ). 
	].

	spec for: #'pharo' do: [
		spec
			package: 'Ma-Serializer-Pharo-Core';
			package: 'Ma-Serializer-Core' with: [
				spec requires: #('Ma-Serializer-Pharo-Core')	
			]
	]
! !

!ConfigurationOfSHMaBase methodsFor: 'symbolic versions' stamp: 'StuartHerring 6/16/2012 13:25'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfSHMaBase methodsFor: 'accessing' stamp: 'StuartHerring 6/16/2012 12:48'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSHMaBase methodsFor: 'versions' stamp: 'StuartHerring 6/16/2012 13:26'!
version13: spec
	<version: '1.3' imports: #('1.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'StuartHerring'.
		spec timestamp: '6/16/2012 13:25'.
		spec 
			package: 'Collections-BTree' with: 'Collections-BTree-lr.73';
			package: 'Ma-Core' with: 'Ma-Core-cmm.214';
			package: 'Ma-Collections' with: 'Ma-Collections-cmm.132';
			package: 'Ma-Ascii-Report' with: 'Ma-Ascii-Report-cmm.9';
			package: 'Ma-Statistics' with: 'Ma-Statistics-cmm.28';
			package: 'Ma-Search' with: 'Ma-Search-cmm.40';
			package: 'Ma-Serializer-Core' with: 'Ma-Serializer-Core-cmm.278';
			package: 'Ma-Serializer-Tests' with: 'Ma-Serializer-Tests-cmm.40'. ].

	spec for: #'pharo' do: [
		spec 
			package: 'Ma-Serializer-Pharo-Core' with: 'Ma-Serializer-Pharo-Core-cmm.1'].
! !
